using OrdinaryDiffEqSymplecticRK, Test, RecursiveArrayTools, DiffEqDevTools, Statistics
using OrdinaryDiffEqTsit5

u0 = fill(0.0, 2)
v0 = ones(2)
function f1_harmonic(dv, v, u, p, t)
    dv .= -u
end
function f2_harmonic(du, v, u, p, t)
    du .= v
end
function harmonic_analytic(y0, p, x)
    v0, u0 = y0.x
    ArrayPartition(-u0 * sin(x) + v0 * cos(x), u0 * cos(x) + v0 * sin(x))
end
ff_harmonic = DynamicalODEFunction(f1_harmonic, f2_harmonic; analytic = harmonic_analytic)
prob = DynamicalODEProblem(ff_harmonic, v0, u0, (0.0, 5.0))

sol = solve(prob, SymplecticEuler(), dt = 1 / 2)
sol_verlet = solve(prob, VelocityVerlet(), dt = 1 / 100)
sol_ruth3 = solve(prob, Ruth3(), dt = 1 / 100)

interp_time = 0:0.001:5
interp = sol(0.5)
interps = sol(interp_time)

sol_tsit5 = solve(prob, Tsit5())

prob = SecondOrderODEProblem(f1_harmonic, v0, u0, (0.0, 5.0))

sol2 = solve(prob, SymplecticEuler(), dt = 1 / 2)
sol2_verlet = solve(prob, VelocityVerlet(), dt = 1 / 100)
sol2_ruth3 = solve(prob, Ruth3(), dt = 1 / 100)

sol2_verlet(0.1)

@test sol[end][1] == sol2[end][1]
@test sol_verlet[end][1] == sol2_verlet[end][1]
@test sol_ruth3[end][1] == sol2_ruth3[end][1]
@test sol[end][3] == sol2[end][3]
@test sol_verlet[end][3] == sol2_verlet[end][3]
@test sol_ruth3[end][3] == sol2_ruth3[end][3]

prob = DynamicalODEProblem(ff_harmonic, v0, u0, (0.0, 5.0))
println("Convergence tests")

dts = 1 .// 2 .^ (6:-1:3)
# Symplectic Euler
sim = test_convergence(dts, prob, SymplecticEuler(), dense_errors = true)
@test sim.𝒪est[:l2]≈1 rtol=1e-1
@test sim.𝒪est[:L2]≈1 rtol=1e-1
# Verlet
sim = test_convergence(dts, prob, VelocityVerlet(), dense_errors = true)
@test sim.𝒪est[:l2]≈2 rtol=1e-1
@test sim.𝒪est[:L2]≈2 rtol=1e-1
# Test that position converges faster for Verlet
position_error = :final => [mean(sim[i].u[2].x[1] - sim[i].u_analytic[2].x[1])
                            for i in 1:length(sim)]
@test first(DiffEqDevTools.calc𝒪estimates(position_error).second)≈4.0 rtol=1e-1

# 2nd Order Tableaus
sim = test_convergence(dts, prob, VerletLeapfrog(), dense_errors = true)
@test sim.𝒪est[:l2]≈2 rtol=1e-1
@test sim.𝒪est[:L2]≈2 rtol=1e-1
sim = test_convergence(dts, prob, LeapfrogDriftKickDrift(), dense_errors = true)
@test sim.𝒪est[:l2]≈2 rtol=1e-1
@test sim.𝒪est[:L2]≈2 rtol=1e-1
sim = test_convergence(dts, prob, PseudoVerletLeapfrog(), dense_errors = true)
@test sim.𝒪est[:l2]≈2 rtol=1e-1
@test sim.𝒪est[:L2]≈2 rtol=1e-1
sim = test_convergence(dts, prob, McAte2(), dense_errors = true)
@test sim.𝒪est[:l2]≈2 rtol=1e-1
@test sim.𝒪est[:L2]≈2 rtol=1e-1

# Ruth
sim = test_convergence(dts, prob, Ruth3(), dense_errors = true)
@test sim.𝒪est[:l2]≈3 rtol=1e-1
@test sim.𝒪est[:L2]≈3 rtol=1e-1
sim = test_convergence(dts, prob, McAte3(), dense_errors = true)
@test sim.𝒪est[:l2]≈3 rtol=1e-1
@test sim.𝒪est[:L2]≈3 rtol=1e-1
sim = test_convergence(dts, prob, CandyRoz4(), dense_errors = true)
@test sim.𝒪est[:l2]≈4 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1
sim = test_convergence(dts, prob, McAte4(), dense_errors = true)
@test sim.𝒪est[:l2]≈4 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1
sim = test_convergence(dts, prob, McAte42(), dense_errors = true)
@test_broken sim.𝒪est[:l2]≈4 rtol=1e-1
@test_broken sim.𝒪est[:L2]≈4 rtol=1e-1
sim = test_convergence(dts, prob, CalvoSanz4(), dense_errors = true)
@test sim.𝒪est[:l2]≈4 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1

dts = 1 .// 2 .^ (4:-1:0)
sim = test_convergence(dts, prob, McAte5(), dense_errors = true)
@test sim.𝒪est[:l2]≈5 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1

sim = test_convergence(dts, prob, Yoshida6(), dense_errors = true)
@test sim.𝒪est[:l2]≈6 rtol=1e-1
@test sim.𝒪est[:L2]≈4.69 rtol=1e-1
sim = test_convergence(dts, prob, KahanLi6(), dense_errors = true)
@test sim.𝒪est[:l2]≈6 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1

sim = test_convergence(dts, prob, McAte8(), dense_errors = true)
@test sim.𝒪est[:l2]≈8 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1

sim = test_convergence(dts, prob, KahanLi8(), dense_errors = true)
@test sim.𝒪est[:l2]≈8 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1

dts = 1.0 ./ 2.0 .^ (2:-1:-2)
sim = test_convergence(dts, prob, SofSpa10(), dense_errors = true)
@test sim.𝒪est[:l2]≈10 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1

################# Out of place symplectic

println("Out of Place")

u0 = 0.0
v0 = 1.0
function f1_harmonic_nip(v, u, p, t)
    -u
end
function f2_harmonic_nip(v, u, p, t)
    v
end

ff_harmonic_nip = DynamicalODEFunction(f1_harmonic_nip, f2_harmonic_nip;
    analytic = harmonic_analytic)
prob = DynamicalODEProblem(ff_harmonic_nip, v0, u0, (0.0, 5.0))

sol = solve(prob, SymplecticEuler(), dt = 1 / 10)

dts = 1 .// 2 .^ (6:-1:3)
# Symplectic Euler
sim = test_convergence(dts, prob, SymplecticEuler(), dense_errors = true)
@test sim.𝒪est[:l2]≈1 rtol=1e-1
@test sim.𝒪est[:L2]≈1 rtol=1e-1
# Verlet
sim = test_convergence(dts, prob, VelocityVerlet(), dense_errors = true)
@test sim.𝒪est[:l2]≈2 rtol=1e-1
@test sim.𝒪est[:L2]≈2 rtol=1e-1
# Test that position converges faster for Verlet
position_error = :final => [mean(sim[i].u[2].x[1] - sim[i].u_analytic[2].x[1])
                            for i in 1:length(sim)]
@test first(DiffEqDevTools.calc𝒪estimates(position_error).second)≈4.0 rtol=1e-1

# 2nd Order Tableaus
sim = test_convergence(dts, prob, VerletLeapfrog(), dense_errors = true)
@test sim.𝒪est[:l2]≈2 rtol=1e-1
@test sim.𝒪est[:L2]≈2 rtol=1e-1
sim = test_convergence(dts, prob, LeapfrogDriftKickDrift(), dense_errors = true)
@test sim.𝒪est[:l2]≈2 rtol=1e-1
@test sim.𝒪est[:L2]≈2 rtol=1e-1
sim = test_convergence(dts, prob, PseudoVerletLeapfrog(), dense_errors = true)
@test sim.𝒪est[:l2]≈2 rtol=1e-1
@test sim.𝒪est[:L2]≈2 rtol=1e-1
sim = test_convergence(dts, prob, McAte2(), dense_errors = true)
@test sim.𝒪est[:l2]≈2 rtol=1e-1
@test sim.𝒪est[:L2]≈2 rtol=1e-1

# Ruth
sim = test_convergence(dts, prob, Ruth3(), dense_errors = true)
@test sim.𝒪est[:l2]≈3 rtol=1e-1
@test sim.𝒪est[:L2]≈3 rtol=1e-1
sim = test_convergence(dts, prob, McAte3(), dense_errors = true)
@test sim.𝒪est[:l2]≈3 rtol=1e-1
@test sim.𝒪est[:L2]≈3 rtol=1e-1
sim = test_convergence(dts, prob, CandyRoz4(), dense_errors = true)
@test sim.𝒪est[:l2]≈4 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1
sim = test_convergence(dts, prob, McAte4(), dense_errors = true)
@test sim.𝒪est[:l2]≈4 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1
sim = test_convergence(dts, prob, McAte42(), dense_errors = true)
@test_broken sim.𝒪est[:l2]≈4 rtol=1e-1
@test_broken sim.𝒪est[:L2]≈4 rtol=1e-1
sim = test_convergence(dts, prob, CalvoSanz4(), dense_errors = true)
@test sim.𝒪est[:l2]≈4 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1

dts = 1 .// 2 .^ (4:-1:0)
sim = test_convergence(dts, prob, McAte5(), dense_errors = true)
@test sim.𝒪est[:l2]≈5 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1

sim = test_convergence(dts, prob, Yoshida6(), dense_errors = true)
@test sim.𝒪est[:l2]≈6 rtol=1e-1
@test sim.𝒪est[:L2]≈4.69 rtol=1e-1
sim = test_convergence(dts, prob, KahanLi6(), dense_errors = true)
@test sim.𝒪est[:l2]≈6 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1

sim = test_convergence(dts, prob, McAte8(), dense_errors = true)
@test sim.𝒪est[:l2]≈8 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1

sim = test_convergence(dts, prob, KahanLi8(), dense_errors = true)
@test sim.𝒪est[:l2]≈8 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1

dts = 1.0 ./ 2.0 .^ (2:-1:-2)
sim = test_convergence(dts, prob, SofSpa10(), dense_errors = true)
@test sim.𝒪est[:l2]≈10 rtol=1e-1
@test sim.𝒪est[:L2]≈4 rtol=1e-1

################# f1 dependent on v

println("f1 dependent on v")

u0 = fill(0.0, 2)
v0 = ones(2)
function f1_v(dv, v, u, p, t)
    dv .= v
end
function f2_v(du, v, u, p, t)
    du .= v
end
function f_v_analytic(y0, p, x)
    v0, u0 = y0.x
    ArrayPartition(v0 * exp(x), v0 * exp(x) - v0 + u0)
end
ff_v = DynamicalODEFunction(f1_v, f2_v; analytic = f_v_analytic)
prob = DynamicalODEProblem(ff_v, v0, u0, (0.0, 5.0))

dts = 1 .// 2 .^ (6:-1:3)
# LeapfrogDriftKickDrift
sim = test_convergence(dts, prob, LeapfrogDriftKickDrift(), dense_errors = true)
@test sim.𝒪est[:l2]≈2 rtol=1e-1
@test sim.𝒪est[:L2]≈2 rtol=1e-1

using Test, LinearAlgebra
using OrdinaryDiffEqSymplecticRK, DiffEqBase
using OrdinaryDiffEqRKN

# algorithm, dq(p) != p, convergence order
const ALGOS = ((SymplecticEuler, true, 1),
    (VelocityVerlet, false, 2),
    (VerletLeapfrog, true, 2),
    (LeapfrogDriftKickDrift, true, 2),
    (PseudoVerletLeapfrog, true, 2),
    (McAte2, true, 2),
    (Ruth3, true, 3),
    (McAte3, true, 3),
    (CandyRoz4, true, 4),
    (McAte4, true, 4),
    (CalvoSanz4, true, 4),
    (McAte42, true, 1), # known to be broken
    (McAte5, true, 5),
    (Yoshida6, true, 6),
    (KahanLi6, true, 6),
    (McAte8, true, 8),
    (KahanLi8, true, 8),
    (SofSpa10, true, 10))

function dp(p, q, pa, t)
    0q .+ pa[2]
end

function dq(p, q, pa, t)
    p .* pa[1]
end

dp(res, p, q, pa, t) = (res .= dp(p, q, pa, t))
dq(res, p, q, pa, t) = (res .= dq(p, q, pa, t))

dynode(iip, dp, dq) = DynamicalODEFunction{iip}(dp, dq)

# [0:1] used in dp, dq; [3:4] start values for p0, q0
const PARAMS = ((1.0, 0.1, 1.0, 0.0), (0.1, 1.0, 1.0, -1.0))
const IIPS = (true, false)
const TSPAN = (0.0, 1.0)

solution(t, w) = (w[2] * t + w[3], (w[2] / 2 * t + w[3]) * w[1] * t + w[4])
apa(iip::Bool, x) = iip ? vcat.(x) : x
errorbound(dt, d, x) = 100 * abs(dt)^d + 1000 * eps(norm(x))
function printerrors(text, calc, solution, pa, t1)
    print(text, ": ")
    print(norm(calc[1] - solution(t1, pa)[1]), " ")
    print(norm(calc[2] - solution(t1, pa)[2]))
    println()
end

@testset "symplectic $alg-$iip-$pa" for (alg, x, d) in ALGOS, iip in IIPS, pa in PARAMS
    dt = 0.01
    tspan = TSPAN
    t0, t1 = tspan
    dynfun = dynode(iip, dp, dq)
    p0, q0 = apa(iip, solution(t0, pa))
    prob = DynamicalODEProblem(dynfun, p0, q0, tspan, pa)

    if x || pa[1] == 1
        sol = solve(prob, alg(); dt = dt)
        calc = sol(t1)
        # printerrors("$alg-$iip-$pa", calc, solution, pa, t1)
        @test calc[1]≈solution(t1, pa)[1] rtol=errorbound(dt, d, calc[1])
        @test calc[2]≈solution(t1, pa)[2] rtol=errorbound(dt, d, calc[2])
    else
        @test_throws ArgumentError solve(prob, alg(); dt = dt)
    end
end

function motionfuncDirect1(dv, v, u, p, t)
    # 1:Electron, 2: Be
    ω_1, ω_2, γ, m_1, m_2, η, ω_d = p
    dv[1] = -ω_1^2 * u[1] * (1 + η * cos(ω_d * t)) - γ * u[2] / m_1
    dv[2] = -ω_2^2 * u[2] - γ * u[1] / m_2
end

function motionfuncDirect1(v, u, p, t)
    # 1:Electron, 2: Be
    ω_1, ω_2, γ, m_1, m_2, η, ω_d = p
    [-ω_1^2 * u[1] * (1 + η * cos(ω_d * t)) - γ * u[2] / m_1,
        -ω_2^2 * u[2] - γ * u[1] / m_2]
end

param = [90386.15717208837, 3938.9288690708827, 8560.718748264337, 0.000544617021484666,
    8.947079933513658, 0.7596480420227258, 78778.57738141765]
u0_direct = zeros(2) # mm, mm
v0_direct = [0.0, 135.83668926684385]
tspan = (0.0, 1.321179076090661)
prob_direct = SecondOrderODEProblem(motionfuncDirect1, v0_direct, u0_direct, tspan, param)
dt = 2e-8
ref = solve(
    prob_direct, DPRKN12(), abstol = 1e-12, reltol = 1e-12, maxiters = 1e7, saveat = 0.01)

@testset "symplectic time-dependent $alg" for (alg, x, d) in ALGOS
    sol = solve(prob_direct, alg(), dt = dt, saveat = 0.01)
    if alg <: Yoshida6
        @test maximum(ref[4, :] - sol[4, :]) < 9e-3
    else
        @test maximum(ref[4, :] - sol[4, :]) < 3e-3
    end
end

using SafeTestsets

@time @safetestset "Synplectic Convergence Tests" include("symplectic_convergence.jl")
@time @safetestset "Synplectic Tests" include("symplectic_tests.jl")
@time @safetestset "JET Tests" include("jet.jl")
@time @safetestset "Aqua" include("qa.jl")

@doc generic_solver_docstring("First order explicit symplectic integrator.",
    "SymplecticEuler",
    "Symplectic Runge-Kutta Methods",
    "https://en.wikipedia.org/wiki/Semi-implicit_Euler_method", "", "")
struct SymplecticEuler <: OrdinaryDiffEqPartitionedAlgorithm end

verlet1967 = """
@article{verlet1967computer,
title={Computer" experiments" on classical fluids. I. Thermodynamical properties of Lennard-Jones molecules},
author={Verlet, Loup},
journal={Physical review},
volume={159},
number={1},
pages={98},
year={1967},
publisher={APS}
}
"""

@doc generic_solver_docstring(
    "2nd order explicit symplectic integrator. Requires f_2(t,u) = v, i.e. a second order ODE.",
    "VelocityVerlet",
    "Symplectic Runge-Kutta Methods",
    verlet1967, "", "")
struct VelocityVerlet <: OrdinaryDiffEqPartitionedAlgorithm end

monaghan2005 = """
@article{monaghan2005,
	title = {Smoothed particle hydrodynamics},
	author = {Monaghan, Joseph J.},
	year = {2005},
	journal = {Reports on Progress in Physics},
	volume = {68},
	number = {8},
	pages = {1703--1759},
	doi = {10.1088/0034-4885/68/8/R01},
}
"""

@doc generic_solver_docstring(
    "2nd order explicit symplectic integrator. Kick-drift-kick form. Requires only one evaluation of `f1` per step.",
    "VerletLeapfrog",
    "Symplectic Runge-Kutta Methods",
    monaghan2005, "", "")
struct VerletLeapfrog <: OrdinaryDiffEqPartitionedAlgorithm end

default_linear_interpolation(alg::VerletLeapfrog, prob) = true

@doc generic_solver_docstring(
    "2nd order explicit symplectic integrator. Drift-kick-drift form of `VerletLeapfrog`
designed to work when `f1` depends on `v`. Requires two evaluation of `f1` per step.",
    "LeapfrogDriftKickDrift",
    "Symplectic Runge-Kutta Methods",
    monaghan2005, "", "")
struct LeapfrogDriftKickDrift <: OrdinaryDiffEqPartitionedAlgorithm end

default_linear_interpolation(alg::LeapfrogDriftKickDrift, prob) = true

@doc generic_solver_docstring("2nd order explicit symplectic integrator.",
    "PseudoVerletLeapfrog",
    "Symplectic Runge-Kutta Methods",
    verlet1967, "", "")
struct PseudoVerletLeapfrog <: OrdinaryDiffEqPartitionedAlgorithm end

mclachlan1992 = """
@article{mclachlan1992accuracy,
title={The accuracy of symplectic integrators},
author={McLachlan, Robert I and Atela, Pau},
journal={Nonlinearity},
volume={5},
number={2},
pages={541},
year={1992},
publisher={IOP Publishing}
}
"""

@doc generic_solver_docstring(
    "Optimized efficiency 2nd order explicit symplectic integrator.",
    "McAte2",
    "Symplectic Runge-Kutta Methods",
    mclachlan1992, "", "")
struct McAte2 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring("3rd order explicit symplectic integrator.",
    "Ruth3",
    "Symplectic Runge-Kutta Methods",
    """@article{ruth1983canonical,
    title={A canonical integration technique},
    author={Ruth, Ronald D},
    journal={IEEE Trans. Nucl. Sci.},
    volume={30},
    number={CERN-LEP-TH-83-14},
    pages={2669--2671},
    year={1983}}""", "", "")
struct Ruth3 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring(
    "Optimized efficiency 3rd order explicit symplectic integrator.",
    "McAte3",
    "Symplectic Runge-Kutta Methods",
    mclachlan1992, "", "")
struct McAte3 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring("4th order explicit symplectic integrator.",
    "CandyRoz4",
    "Symplectic Runge-Kutta Methods",
    """@article{candy1991symplectic,
    itle={A symplectic integration algorithm for separable Hamiltonian functions},
    uthor={Candy, J and Rozmus, W},
    ournal={Journal of Computational Physics},
    olume={92},
    umber={1},
    ages={230--256},
    ear={1991},
    publisher={Elsevier}}""", "", "")
struct CandyRoz4 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring(
    "4th order explicit symplectic integrator. Requires quadratic kinetic energy.",
    "McAte4",
    "Symplectic Runge-Kutta Methods",
    mclachlan1992, "", "")
struct McAte4 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring(
    "Optimized efficiency 4th order explicit symplectic integrator.",
    "CalvoSanz4",
    "Symplectic Runge-Kutta Methods",
    """@article{sanz1993symplectic,
    title={Symplectic numerical methods for Hamiltonian problems},
    author={Sanz-Serna, Jes{\'u}s Maria and Calvo, Mari-Paz},
    journal={International Journal of Modern Physics C},
    volume={4},
    number={02},
    pages={385--392},
    year={1993},
    publisher={World Scientific}
    }""", "", "")
struct CalvoSanz4 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring("4th order explicit symplectic integrator. BROKEN",
    "McAte42",
    "Symplectic Runge-Kutta Methods",
    mclachlan1992, "", "")
struct McAte42 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring(
    "Optimized efficiency 5th order explicit symplectic integrator. Requires quadratic kinetic energy.",
    "McAte5",
    "Symplectic Runge-Kutta Methods",
    mclachlan1992, "", "")
struct McAte5 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring("6th order explicit symplectic integrator.",
    "Yoshida6",
    "Symplectic Runge-Kutta Methods",
    """@article{yoshida1990construction,
    title={Construction of higher order symplectic integrators},
    author={Yoshida, Haruo},
    journal={Physics letters A},
    volume={150},
    number={5-7},
    pages={262--268},
    year={1990},
    publisher={Elsevier}}""", "", "")
struct Yoshida6 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring(
    "Optimized efficiency 6th order explicit symplectic integrator.",
    "KahanLi6",
    "Symplectic Runge-Kutta Methods",
    """@article{yoshida1990construction,
    title={Construction of higher order symplectic integrators},
    author={Yoshida, Haruo},
    journal={Physics letters A},
    volume={150},
    number={5-7},
    pages={262--268},
    year={1990},
    publisher={Elsevier}}""", "", "")
struct KahanLi6 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring("8th order explicit symplectic integrator.",
    "McAte8",
    "Symplectic Runge-Kutta Methods",
    """@article{mclachlan1995numerical,
    title={On the numerical integration of ordinary differential equations by symmetric composition methods},
    author={McLachlan, Robert I},
    journal={SIAM Journal on Scientific Computing},
    volume={16},
    number={1},
    pages={151--168},
    year={1995},
    publisher={SIAM}
    }""", "", "")
struct McAte8 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring(
    "Optimized efficiency 8th order explicit symplectic integrator.",
    "KahanLi8",
    "Symplectic Runge-Kutta Methods",
    """@article{kahan1997composition,
    title={Composition constants for raising the orders of unconventional schemes for ordinary differential equations},
    author={Kahan, William and Li, Ren-Cang},
    journal={Mathematics of computation},
    volume={66},
    number={219},
    pages={1089--1099},
    year={1997}}""", "", "")
struct KahanLi8 <: OrdinaryDiffEqPartitionedAlgorithm end

@doc generic_solver_docstring("10th order explicit symplectic integrator.",
    "SofSpa10",
    "Symplectic Runge-Kutta Methods",
    """@article{sofroniou2005derivation,
    title={Derivation of symmetric composition constants for symmetric integrators},
    author={Sofroniou, Mark and Spaletta, Giulia},
    journal={Optimization Methods and Software},
    volume={20},
    number={4-5},
    pages={597--613},
    year={2005},
    publisher={Taylor \\& Francis}}""", "", "")
struct SofSpa10 <: OrdinaryDiffEqPartitionedAlgorithm end

module OrdinaryDiffEqSymplecticRK

import OrdinaryDiffEqCore: alg_order, calculate_residuals!,
                           initialize!, perform_step!, unwrap_alg,
                           calculate_residuals,
                           OrdinaryDiffEqAlgorithm,
                           OrdinaryDiffEqMutableCache, OrdinaryDiffEqConstantCache,
                           OrdinaryDiffEqAdaptiveAlgorithm,
                           OrdinaryDiffEqPartitionedAlgorithm,
                           CompiledFloats, uses_uprev,
                           alg_cache, _vec, _reshape, @cache, isfsal, full_cache,
                           constvalue, _unwrap_val,
                           explicit_rk_docstring, trivial_limiter!,
                           _ode_interpolant!, _ode_addsteps!, get_fsalfirstlast,
                           generic_solver_docstring, default_linear_interpolation
using FastBroadcast, Polyester, MuladdMacro, RecursiveArrayTools
import OrdinaryDiffEqCore

using Reexport
@reexport using SciMLBase

include("algorithms.jl")
include("alg_utils.jl")
include("symplectic_caches.jl")
include("symplectic_tableaus.jl")
include("symplectic_perform_step.jl")

export SymplecticEuler, VelocityVerlet, VerletLeapfrog, LeapfrogDriftKickDrift,
       PseudoVerletLeapfrog, McAte2, Ruth3, McAte3, CandyRoz4, McAte4, McAte42, McAte5,
       CalvoSanz4, Yoshida6, KahanLi6, McAte8, KahanLi8, SofSpa10

end

# http://www.chimica.unipd.it/antonino.polimeno/pubblica/downloads/JChemPhys_101_4062.pdf

function initialize!(integrator, cache::SymplecticEulerConstantCache)
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)
    # Do the calculation pre
    # So that way FSAL interpolation
    duprev, uprev = integrator.uprev.x
    du, u = integrator.u.x
    kdu = integrator.f.f1(duprev, uprev, integrator.p, integrator.t)
    kuprev = integrator.f.f2(duprev, uprev, integrator.p, integrator.t)
    @muladd du = duprev + integrator.dt * kdu
    ku = integrator.f.f2(du, uprev, integrator.p, integrator.t)
    integrator.stats.nf2 += 1
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
    integrator.fsalfirst = ArrayPartition((kdu, kuprev))
    integrator.fsallast = ArrayPartition((zero(kdu), ku))
end

@muladd function perform_step!(integrator, cache::SymplecticEulerConstantCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    kuprev = integrator.fsalfirst.x[2]
    u = uprev + dt * kuprev
    # Now actually compute the step
    # Do it at the end for interpolations!
    kdu = f.f1(duprev, u, p, t)
    du = duprev + dt * kdu

    ku = f.f2(du, u, p, t)
    integrator.stats.nf2 += 1
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)

    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((kdu, ku))
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
end

function initialize!(integrator, cache::SymplecticEulerCache)
    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    # Do the calculation pre
    # So that way FSAL interpolation
    duprev, uprev = integrator.uprev.x
    du, u = integrator.u.x
    kuprev = integrator.fsalfirst.x[2]
    kdu, ku = integrator.fsallast.x
    integrator.f.f1(kdu, duprev, uprev, integrator.p, integrator.t)
    integrator.f.f2(kuprev, duprev, uprev, integrator.p, integrator.t)
    @muladd @.. broadcast=false du=duprev + integrator.dt * kdu
    integrator.f.f2(ku, du, uprev, integrator.p, integrator.t)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.stats.nf2 += 2
end

@muladd function perform_step!(integrator, cache::SymplecticEulerCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = integrator.uprev.x
    du, u = integrator.u.x
    kuprev = integrator.fsalfirst.x[2]
    kdu, ku = integrator.fsallast.x
    @.. broadcast=false u=uprev + dt * kuprev
    # Now actually compute the step
    # Do it at the end for interpolations!
    integrator.stats.nf2 += 1
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    f.f1(kdu, duprev, u, p, t)
    @.. broadcast=false du=duprev + dt * kdu
    f.f2(ku, du, u, p, t)
end

# some of the algorithms are designed only for the case
# f.f2(p, q, pa, t) = p which is the Newton/Lagrange equations
# If called with different functions (which are possible in the Hamiltonian case)
# an exception is thrown to avoid silently calculate wrong results.
function verify_f2(f::F, p, q, pa, t, ::Any,
        ::C) where {F, C <: Union{HamiltonConstantCache, VerletLeapfrogConstantCache,
        LeapfrogDriftKickDriftConstantCache}}
    f(p, q, pa, t)
end
function verify_f2(f::F, res, p, q, pa, t, ::Any,
        ::C) where {F, C <: Union{HamiltonMutableCache, VerletLeapfrogCache,
        LeapfrogDriftKickDriftCache}}
    f(res, p, q, pa, t)
end

function verify_f2(f::F, p, q, pa, t, integrator, ::C) where {F, C <: VelocityVerletConstantCache}
    res = f(p, q, pa, t)
    res == p ? p : throwex(integrator)
end
function verify_f2(f::F, res, p, q, pa, t, integrator, ::C) where {F, C <: VelocityVerletCache}
    f(res, p, q, pa, t)
    res == p ? res : throwex(integrator)
end
function throwex(integrator)
    algn = typeof(integrator.alg)
    throw(ArgumentError("Algorithm $algn is not applicable if f2(p, q, t) != p"))
end

# provide the mutable uninitialized objects to keep state and derivative in case of mutable caches
# no such objects are required for constant caches
function alloc_symp_state(integrator)
    (integrator.u.x..., integrator.cache.tmp.x...)
end

# load state and derivatives at begin of symplectic iteration steps
function load_symp_state(integrator)
    (integrator.uprev.x..., integrator.fsallast.x...)
end

# store state and derivatives at the end of symplectic iteration steps
function store_symp_state!(integrator, ::OrdinaryDiffEqConstantCache, du, u, kdu, ku)
    integrator.u = ArrayPartition((du, u))
    integrator.fsallast = ArrayPartition((kdu, ku))
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast
    nothing
end

function store_symp_state!(integrator, ::OrdinaryDiffEqMutableCache, kdu, ku)
    copyto!(integrator.k[1].x[1], integrator.k[2].x[1])
    copyto!(integrator.k[1].x[2], integrator.k[2].x[2])
    copyto!(integrator.k[2].x[2], ku)
    copyto!(integrator.k[2].x[1], kdu)
    nothing
end

function initialize!(integrator,
        cache::C) where {C <: Union{HamiltonMutableCache, VelocityVerletCache,
        VerletLeapfrogCache, LeapfrogDriftKickDriftCache}}
    integrator.kshortsize = 2
    resize!(integrator.k, integrator.kshortsize)
    integrator.k[1] = integrator.fsalfirst
    integrator.k[2] = integrator.fsallast

    duprev, uprev = integrator.uprev.x
    integrator.f.f1(integrator.k[2].x[1], duprev, uprev, integrator.p, integrator.t)
    verify_f2(integrator.f.f2, integrator.k[2].x[2], duprev, uprev, integrator.p,
        integrator.t, integrator, cache)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.stats.nf2 += 1
end

function initialize!(integrator,
        cache::C) where {C <: Union{HamiltonConstantCache, VelocityVerletConstantCache,
        VerletLeapfrogConstantCache, LeapfrogDriftKickDriftConstantCache}}
    integrator.kshortsize = 2
    integrator.k = typeof(integrator.k)(undef, integrator.kshortsize)

    duprev, uprev = integrator.uprev.x
    kdu = integrator.f.f1(duprev, uprev, integrator.p, integrator.t)
    ku = verify_f2(integrator.f.f2, duprev, uprev, integrator.p, integrator.t, integrator,
        cache)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.stats.nf2 += 1
    integrator.fsallast = ArrayPartition((kdu, ku))
    integrator.k[2] = integrator.fsallast
    integrator.fsalfirst = integrator.fsallast
end

@muladd function perform_step!(integrator, cache::VelocityVerletConstantCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = load_symp_state(integrator)

    # x(t+Δt) = x(t) + v(t)*Δt + 1/2*a(t)*Δt^2
    ku = integrator.fsallast.x[1]
    dtsq = dt^2
    half = cache.half
    u = uprev + dt * duprev + dtsq * (half * ku)
    kdu = f.f1(duprev, u, p, t + dt)
    # v(t+Δt) = v(t) + 1/2*(a(t)+a(t+Δt))*Δt
    du = duprev + dt * (half * ku + half * kdu)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    store_symp_state!(integrator, cache, du, u, kdu, du)
end

@muladd function perform_step!(integrator, cache::VelocityVerletCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev = load_symp_state(integrator)
    du, u, kdu, ku = alloc_symp_state(integrator)

    # x(t+Δt) = x(t) + v(t)*Δt + 1/2*a(t)*Δt^2
    ku = integrator.fsallast.x[1]
    dtsq = dt^2
    half = cache.half
    @.. broadcast=false u=uprev + dt * duprev + dtsq * (half * ku)
    f.f1(kdu, duprev, u, p, t + dt)
    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    # v(t+Δt) = v(t) + 1/2*(a(t)+a(t+Δt))*Δt
    @.. broadcast=false du=duprev + dt * (half * ku + half * kdu)

    store_symp_state!(integrator, cache, kdu, du)
end

@muladd function perform_step!(integrator, cache::VerletLeapfrogConstantCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev, kduprev, _ = load_symp_state(integrator)

    # kick-drift-kick scheme of the Leapfrog method:
    # update velocity
    half = cache.half
    du = duprev + dt * half * kduprev

    # update position
    ku = f.f2(du, uprev, p, t + half * dt)
    u = uprev + dt * ku

    # update velocity
    kdu = f.f1(du, u, p, t + dt)
    du = du + dt * half * kdu

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.stats.nf2 += 1
    store_symp_state!(integrator, cache, du, u, kdu, ku)
end

@muladd function perform_step!(integrator, cache::VerletLeapfrogCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev, kduprev, _ = load_symp_state(integrator)
    du, u, kdu, ku = alloc_symp_state(integrator)

    # kick-drift-kick scheme of the Leapfrog method:
    # update velocity
    half = cache.half
    @.. broadcast=false du=duprev + dt * half * kduprev

    # update position
    f.f2(ku, du, uprev, p, t + half * dt)
    @.. broadcast=false u=uprev + dt * ku

    # update velocity
    f.f1(kdu, du, u, p, t + dt)
    @.. broadcast=false du=du + dt * half * kdu

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    integrator.stats.nf2 += 1
    store_symp_state!(integrator, cache, kdu, ku)
end

@muladd function perform_step!(integrator, cache::LeapfrogDriftKickDriftConstantCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev, _, _ = load_symp_state(integrator)

    # drift-kick-drift scheme of the Leapfrog method, allowing for f1 to depend on v:
    # update position half step
    half = cache.half
    ku = f.f2(duprev, uprev, p, t)
    u = uprev + dt * half * ku

    # update velocity half step
    kdu = f.f1(duprev, uprev, p, t)
    du = duprev + dt * half * kdu

    # update velocity (add to previous full step velocity)
    # note that this extra step is only necessary if f1 depends on v/du (or t)
    kdu = f.f1(du, u, p, t + half * dt)
    du = duprev + dt * kdu

    # update position (add to half step position)
    ku = f.f2(du, u, p, t + dt)
    u = u + dt * half * ku

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
    integrator.stats.nf2 += 2
    store_symp_state!(integrator, cache, du, u, kdu, ku)
end

@muladd function perform_step!(integrator, cache::LeapfrogDriftKickDriftCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    duprev, uprev, _, _ = load_symp_state(integrator)
    du, u, kdu, ku = alloc_symp_state(integrator)

    # drift-kick-drift scheme of the Leapfrog method, allowing for f1 to depend on v:
    # update position half step
    half = cache.half
    f.f2(ku, duprev, uprev, p, t)
    @.. broadcast=false u=uprev + dt * half * ku

    # update velocity half step
    f.f1(kdu, duprev, uprev, p, t)
    @.. broadcast=false du=duprev + dt * half * kdu

    # update velocity (add to previous full step velocity)
    # note that this extra step is only necessary if f1 depends on v/du (or t)
    f.f1(kdu, du, u, p, t + half * dt)
    @.. broadcast=false du=duprev + dt * kdu

    # update position (add to half step position)
    f.f2(ku, du, u, p, t + dt)
    @.. broadcast=false u=u + dt * half * ku

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 2)
    integrator.stats.nf2 += 2
    store_symp_state!(integrator, cache, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic2ConstantCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, b1, b2) = cache
    duprev, uprev, _, kuprev = load_symp_state(integrator)

    # update position
    u = uprev + dt * b1 * kuprev
    # update velocity
    kdu = f.f1(duprev, u, p, t)
    du = duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b2 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a2 * kdu
    kdu = f.f1(du, u, p, tnew)
    ku = f.f2(du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
    integrator.stats.nf2 += 2
    store_symp_state!(integrator, cache, du, u, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic2Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, b1, b2) = cache.tab
    duprev, uprev, _, kuprev = load_symp_state(integrator)
    du, u, kdu, ku = alloc_symp_state(integrator)

    # update position
    @.. broadcast=false u=uprev + dt * b1 * kuprev
    # update velocity
    f.f1(kdu, duprev, u, p, t)
    @.. broadcast=false du=duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b2 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a2 * kdu
    f.f1(kdu, du, u, p, tnew)
    f.f2(ku, du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 3)
    integrator.stats.nf2 += 2
    store_symp_state!(integrator, cache, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic3ConstantCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, b1, b2, b3) = cache
    duprev, uprev, _, kuprev = load_symp_state(integrator)

    # update position
    u = uprev + dt * b1 * kuprev
    # update velocity
    kdu = f.f1(duprev, u, p, integrator.t)
    du = duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b2 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b3 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a3 * kdu
    kdu = f.f1(du, u, p, tnew)
    ku = f.f2(du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 3
    store_symp_state!(integrator, cache, du, u, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic3Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, b1, b2, b3) = cache.tab
    duprev, uprev, _, kuprev = load_symp_state(integrator)
    du, u, kdu, ku = alloc_symp_state(integrator)

    # update position
    @.. broadcast=false u=uprev + dt * b1 * kuprev
    # update velocity
    f.f1(kdu, duprev, u, p, integrator.t)
    @.. broadcast=false du=duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b2 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b3 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a3 * kdu
    f.f1(kdu, du, u, p, tnew)
    f.f2(ku, du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 4)
    integrator.stats.nf2 += 3
    store_symp_state!(integrator, cache, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic4ConstantCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, b1, b2, b3, b4) = cache
    duprev, uprev, _, kuprev = load_symp_state(integrator)

    # update position
    u = uprev + dt * b1 * kuprev
    # update velocity
    kdu = f.f1(duprev, u, p, t)
    du = duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b2 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b3 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b4 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a4 * kdu
    kdu = f.f1(du, u, p, tnew)
    ku = f.f2(du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    integrator.stats.nf2 += 4
    store_symp_state!(integrator, cache, du, u, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic4Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, b1, b2, b3, b4) = cache.tab
    duprev, uprev, _, kuprev = load_symp_state(integrator)
    du, u, kdu, ku = alloc_symp_state(integrator)

    # update position
    @.. broadcast=false u=uprev + dt * b1 * kuprev
    # update velocity
    f.f1(kdu, duprev, u, p, t)
    @.. broadcast=false du=duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b2 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b3 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b4 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a4 * kdu
    f.f1(kdu, du, u, p, tnew)
    f.f2(ku, du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    integrator.stats.nf2 += 4
    store_symp_state!(integrator, cache, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic45ConstantCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    alg = unwrap_alg(integrator, false)
    (; a1, a2, a3, a4, a5, b1, b2, b3, b4, b5) = cache
    duprev, uprev, _, kuprev = load_symp_state(integrator)

    # update position
    u = uprev + dt * b1 * kuprev
    # update velocity
    kdu = f.f1(duprev, u, p, t)
    du = duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b2 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b3 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b4 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b5 * ku

    kdu = f.f1(du, u, p, tnew)
    if alg isa McAte42
        du = du + dt * a5 * kdu
        kdu = f.f1(du, u, p, tnew)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end
    ku = f.f2(du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    integrator.stats.nf2 += 5
    store_symp_state!(integrator, cache, du, u, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic45Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    alg = unwrap_alg(integrator, false)
    (; a1, a2, a3, a4, a5, b1, b2, b3, b4, b5) = cache.tab
    duprev, uprev, _, kuprev = load_symp_state(integrator)
    du, u, kdu, ku = alloc_symp_state(integrator)

    # update position
    @.. broadcast=false u=uprev + dt * b1 * kuprev
    # update velocity
    f.f1(kdu, duprev, u, p, t)
    @.. broadcast=false du=duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b2 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b3 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b4 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b5 * ku

    f.f1(kdu, du, u, p, tnew)
    if alg isa McAte42
        @.. broadcast=false du=du + dt * a5 * kdu
        f.f1(kdu, du, u, p, tnew)
        OrdinaryDiffEqCore.increment_nf!(integrator.stats, 1)
    end
    f.f2(ku, du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 5)
    integrator.stats.nf2 += 5
    store_symp_state!(integrator, cache, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic5ConstantCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, a5, a6, b1, b2, b3, b4, b5, b6) = cache
    duprev, uprev, _, kuprev = load_symp_state(integrator)

    # update position
    u = uprev + dt * b1 * kuprev
    # update velocity
    kdu = f.f1(duprev, u, p, integrator.t)
    du = duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b2 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b3 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b4 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b5 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a5 * kdu

    tnew = tnew + a5 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b6 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a6 * kdu
    kdu = f.f1(du, u, p, tnew)
    ku = f.f2(du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 7)
    integrator.stats.nf2 += 6
    store_symp_state!(integrator, cache, du, u, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic5Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, a5, a6, b1, b2, b3, b4, b5, b6) = cache.tab
    duprev, uprev, _, kuprev = load_symp_state(integrator)
    du, u, kdu, ku = alloc_symp_state(integrator)

    # update position
    @.. broadcast=false u=uprev + dt * b1 * kuprev
    # update velocity
    f.f1(kdu, duprev, u, p, integrator.t)
    @.. broadcast=false du=duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b2 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b3 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b4 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b5 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a5 * kdu

    tnew = tnew + a5 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b6 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a6 * kdu
    f.f1(kdu, du, u, p, tnew)
    f.f2(ku, du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 7)
    integrator.stats.nf2 += 6
    store_symp_state!(integrator, cache, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic6ConstantCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, a5, a6, a7, a8, b1, b2, b3, b4, b5, b6, b7, b8) = cache
    duprev, uprev, _, kuprev = load_symp_state(integrator)

    # update position
    u = uprev + dt * b1 * kuprev
    # update velocity
    kdu = f.f1(duprev, u, p, integrator.t)
    du = duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b2 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b3 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b4 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b5 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a5 * kdu

    tnew = tnew + a5 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b6 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a6 * kdu

    tnew = tnew + a6 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b7 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a7 * kdu

    tnew = tnew + a7 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b8 * ku

    kdu = f.f1(du, u, p, tnew)
    # @.. broadcast=false du = du + dt*a8*kdu
    ku = f.f2(du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 8)
    integrator.stats.nf2 += 8
    store_symp_state!(integrator, cache, du, u, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic6Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, a5, a6, a7, a8, b1, b2, b3, b4, b5, b6, b7, b8) = cache.tab
    duprev, uprev, _, kuprev = load_symp_state(integrator)
    du, u, kdu, ku = alloc_symp_state(integrator)

    # update position
    @.. broadcast=false u=uprev + dt * b1 * kuprev
    # update velocity
    f.f1(kdu, duprev, u, p, integrator.t)
    @.. broadcast=false du=duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b2 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b3 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b4 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b5 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a5 * kdu

    tnew = tnew + a5 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b6 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a6 * kdu

    tnew = tnew + a6 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b7 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a7 * kdu

    tnew = tnew + a7 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b8 * ku

    f.f1(kdu, du, u, p, tnew)
    # @.. broadcast=false du = du + dt*a8*kdu
    f.f2(ku, du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 8)
    integrator.stats.nf2 += 8
    store_symp_state!(integrator, cache, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic62ConstantCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10) = cache
    duprev, uprev, _, kuprev = load_symp_state(integrator)

    # update position
    u = uprev + dt * b1 * kuprev
    # update velocity
    kdu = f.f1(duprev, u, p, integrator.t)
    du = duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b2 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b3 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b4 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b5 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a5 * kdu

    tnew = tnew + a5 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b6 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a6 * kdu

    tnew = tnew + a6 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b7 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a7 * kdu

    tnew = tnew + a7 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b8 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a8 * kdu

    tnew = tnew + a8 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b9 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a9 * kdu

    tnew = tnew + a9 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b10 * ku

    kdu = f.f1(du, u, p, tnew)
    # @.. broadcast=false du = du + dt*a10*kdu
    ku = f.f2(du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 10)
    integrator.stats.nf2 += 10
    store_symp_state!(integrator, cache, du, u, kdu, ku)
end

@muladd function perform_step!(integrator, cache::Symplectic62Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, b1, b2, b3, b4, b5, b6, b7, b8, b9, b10) = cache.tab
    duprev, uprev, _, kuprev = load_symp_state(integrator)
    du, u, kdu, ku = alloc_symp_state(integrator)

    # update position
    @.. broadcast=false u=uprev + dt * b1 * kuprev
    # update velocity
    f.f1(kdu, duprev, u, p, integrator.t)
    @.. broadcast=false du=duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b2 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b3 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b4 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b5 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a5 * kdu

    tnew = tnew + a5 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b6 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a6 * kdu

    tnew = tnew + a6 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b7 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a7 * kdu

    tnew = tnew + a7 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b8 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a8 * kdu

    tnew = tnew + a8 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b9 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a9 * kdu

    tnew = tnew + a9 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b10 * ku

    f.f1(kdu, du, u, p, tnew)
    # @.. broadcast=false du = du + dt*a10*kdu
    f.f2(ku, du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 10)
    integrator.stats.nf2 += 10
    store_symp_state!(integrator, cache, kdu, ku)
end

@muladd function perform_step!(integrator, cache::McAte8ConstantCache, repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16,
    b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15, b16) = cache
    duprev, uprev, _, kuprev = load_symp_state(integrator)

    # update position
    u = uprev + dt * b1 * kuprev
    # update velocity
    kdu = f.f1(duprev, u, p, integrator.t)
    du = duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b2 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b3 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b4 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b5 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a5 * kdu

    tnew = tnew + a5 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b6 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a6 * kdu

    tnew = tnew + a6 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b7 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a7 * kdu

    tnew = tnew + a7 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b8 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a8 * kdu

    tnew = tnew + a8 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b9 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a9 * kdu

    tnew = tnew + a9 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b10 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a10 * kdu

    tnew = tnew + a10 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b11 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a11 * kdu

    tnew = tnew + a11 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b12 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a12 * kdu

    tnew = tnew + a12 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b13 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a13 * kdu

    tnew = tnew + a13 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b14 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a14 * kdu

    tnew = tnew + a14 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b15 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a15 * kdu

    tnew = tnew + a15 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b16 * ku

    kdu = f.f1(du, u, p, tnew)
    # @.. broadcast=false du = du + dt*a16*kdu
    ku = f.f2(du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 16)
    integrator.stats.nf2 += 16
    store_symp_state!(integrator, cache, du, u, kdu, ku)
end

@muladd function perform_step!(integrator, cache::McAte8Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16,
    b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15, b16) = cache.tab
    duprev, uprev, _, kuprev = load_symp_state(integrator)
    du, u, kdu, ku = alloc_symp_state(integrator)

    # update position
    @.. broadcast=false u=uprev + dt * b1 * kuprev
    # update velocity
    f.f1(kdu, duprev, u, p, integrator.t)
    @.. broadcast=false du=duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b2 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b3 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b4 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b5 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a5 * kdu

    tnew = tnew + a5 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b6 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a6 * kdu

    tnew = tnew + a6 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b7 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a7 * kdu

    tnew = tnew + a7 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b8 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a8 * kdu

    tnew = tnew + a8 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b9 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a9 * kdu

    tnew = tnew + a9 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b10 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a10 * kdu

    tnew = tnew + a10 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b11 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a11 * kdu

    tnew = tnew + a11 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b12 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a12 * kdu

    tnew = tnew + a12 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b13 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a13 * kdu

    tnew = tnew + a13 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b14 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a14 * kdu

    tnew = tnew + a14 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b15 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a15 * kdu

    tnew = tnew + a15 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b16 * ku

    f.f1(kdu, du, u, p, tnew)
    # @.. broadcast=false du = du + dt*a16*kdu
    f.f2(ku, du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 16)
    integrator.stats.nf2 += 16
    store_symp_state!(integrator, cache, kdu, ku)
end

@muladd function perform_step!(integrator, cache::KahanLi8ConstantCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18,
    b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15, b16, b17, b18) = cache
    duprev, uprev, _, kuprev = load_symp_state(integrator)

    # update position
    u = uprev + dt * b1 * kuprev
    # update velocity
    kdu = f.f1(duprev, u, p, integrator.t)
    du = duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b2 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b3 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b4 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b5 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a5 * kdu

    tnew = tnew + a5 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b6 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a6 * kdu

    tnew = tnew + a6 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b7 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a7 * kdu

    tnew = tnew + a7 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b8 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a8 * kdu

    tnew = tnew + a8 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b9 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a9 * kdu

    tnew = tnew + a9 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b10 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a10 * kdu

    tnew = tnew + a10 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b11 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a11 * kdu

    tnew = tnew + a11 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b12 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a12 * kdu

    tnew = tnew + a12 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b13 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a13 * kdu

    tnew = tnew + a13 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b14 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a14 * kdu

    tnew = tnew + a14 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b15 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a15 * kdu

    tnew = tnew + a15 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b16 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a16 * kdu

    tnew = tnew + a16 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b17 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a17 * kdu

    tnew = tnew + a17 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b18 * ku

    kdu = f.f1(du, u, p, tnew)
    # @.. broadcast=false du = du + dt*a18*kdu
    ku = f.f2(du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 18)
    integrator.stats.nf2 += 18
    store_symp_state!(integrator, cache, du, u, kdu, ku)
end

@muladd function perform_step!(integrator, cache::KahanLi8Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18,
    b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15, b16, b17, b18) = cache.tab
    duprev, uprev, _, kuprev = load_symp_state(integrator)
    du, u, kdu, ku = alloc_symp_state(integrator)

    # update position
    @.. broadcast=false u=uprev + dt * b1 * kuprev
    # update velocity
    f.f1(kdu, duprev, u, p, integrator.t)
    @.. broadcast=false du=duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b2 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b3 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b4 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b5 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a5 * kdu

    tnew = tnew + a5 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b6 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a6 * kdu

    tnew = tnew + a6 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b7 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a7 * kdu

    tnew = tnew + a7 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b8 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a8 * kdu

    tnew = tnew + a8 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b9 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a9 * kdu

    tnew = tnew + a9 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b10 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a10 * kdu

    tnew = tnew + a10 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b11 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a11 * kdu

    tnew = tnew + a11 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b12 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a12 * kdu

    tnew = tnew + a12 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b13 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a13 * kdu

    tnew = tnew + a13 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b14 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a14 * kdu

    tnew = tnew + a14 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b15 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a15 * kdu

    tnew = tnew + a15 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b16 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a16 * kdu

    tnew = tnew + a16 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b17 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a17 * kdu

    tnew = tnew + a17 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b18 * ku

    f.f1(kdu, du, u, p, tnew)
    # @.. broadcast=false du = du + dt*a18*kdu
    f.f2(ku, du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 18)
    integrator.stats.nf2 += 18
    store_symp_state!(integrator, cache, kdu, ku)
end

@muladd function perform_step!(integrator, cache::SofSpa10ConstantCache,
        repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18,
    a19, a20, a21, a22, a23, a24, a25, a26, a27, a28, a29, a30, a31, a32, a33, a34,
    a35, a36,
    b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15, b16, b17, b18,
    b19, b20, b21, b22, b23, b24, b25, b26, b27, b28, b29, b30, b31, b32, b33, b34,
    b35, b36) = cache
    duprev, uprev, _, kuprev = load_symp_state(integrator)

    # update position
    u = uprev + dt * b1 * kuprev
    # update velocity
    kdu = f.f1(duprev, u, p, integrator.t)
    du = duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b2 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b3 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b4 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b5 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a5 * kdu

    tnew = tnew + a5 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b6 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a6 * kdu

    tnew = tnew + a6 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b7 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a7 * kdu

    tnew = tnew + a7 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b8 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a8 * kdu

    tnew = tnew + a8 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b9 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a9 * kdu

    tnew = tnew + a9 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b10 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a10 * kdu

    tnew = tnew + a10 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b11 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a11 * kdu

    tnew = tnew + a11 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b12 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a12 * kdu

    tnew = tnew + a12 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b13 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a13 * kdu

    tnew = tnew + a13 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b14 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a14 * kdu

    tnew = tnew + a14 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b15 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a15 * kdu

    tnew = tnew + a15 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b16 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a16 * kdu

    tnew = tnew + a16 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b17 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a17 * kdu

    tnew = tnew + a17 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b18 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a18 * kdu

    tnew = tnew + a18 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b19 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a19 * kdu

    tnew = tnew + a19 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b20 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a20 * kdu

    tnew = tnew + a20 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b21 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a21 * kdu

    tnew = tnew + a21 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b22 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a22 * kdu

    tnew = tnew + a22 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b23 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a23 * kdu

    tnew = tnew + a23 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b24 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a24 * kdu

    tnew = tnew + a24 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b25 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a25 * kdu

    tnew = tnew + a25 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b26 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a26 * kdu

    tnew = tnew + a26 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b27 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a27 * kdu

    tnew = tnew + a27 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b28 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a28 * kdu

    tnew = tnew + a28 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b29 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a29 * kdu

    tnew = tnew + a29 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b30 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a30 * kdu

    tnew = tnew + a30 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b31 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a31 * kdu

    tnew = tnew + a31 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b32 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a32 * kdu

    tnew = tnew + a32 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b33 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a33 * kdu

    tnew = tnew + a33 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b34 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a34 * kdu

    tnew = tnew + a34 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b35 * ku

    kdu = f.f1(du, u, p, tnew)
    du = du + dt * a35 * kdu

    tnew = tnew + a35 * dt
    ku = f.f2(du, u, p, tnew)
    u = u + dt * b36 * ku

    kdu = f.f1(du, u, p, tnew)
    # @.. broadcast=false du = du + dt*a30*kdu
    ku = f.f2(du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 36)
    integrator.stats.nf2 += 36
    store_symp_state!(integrator, cache, du, u, kdu, ku)
end

@muladd function perform_step!(integrator, cache::SofSpa10Cache, repeat_step = false)
    (; t, dt, f, p) = integrator
    (; a1, a2, a3, a4, a5, a6, a7, a8, a9, a10, a11, a12, a13, a14, a15, a16, a17, a18,
    a19, a20, a21, a22, a23, a24, a25, a26, a27, a28, a29, a30, a31, a32, a33, a34,
    a35, a36,
    b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15, b16, b17, b18,
    b19, b20, b21, b22, b23, b24, b25, b26, b27, b28, b29, b30, b31, b32, b33, b34,
    b35, b36) = cache.tab
    duprev, uprev, _, kuprev = load_symp_state(integrator)
    du, u, kdu, ku = alloc_symp_state(integrator)

    # update position
    @.. broadcast=false u=uprev + dt * b1 * kuprev
    # update velocity
    f.f1(kdu, duprev, u, p, integrator.t)
    @.. broadcast=false du=duprev + dt * a1 * kdu
    # update position & velocity
    tnew = t + a1 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b2 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a2 * kdu

    # update position & velocity
    tnew = tnew + a2 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b3 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a3 * kdu

    # update position & velocity
    tnew = tnew + a3 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b4 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a4 * kdu

    # update position & velocity
    tnew = tnew + a4 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b5 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a5 * kdu

    tnew = tnew + a5 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b6 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a6 * kdu

    tnew = tnew + a6 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b7 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a7 * kdu

    tnew = tnew + a7 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b8 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a8 * kdu

    tnew = tnew + a8 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b9 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a9 * kdu

    tnew = tnew + a9 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b10 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a10 * kdu

    tnew = tnew + a10 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b11 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a11 * kdu

    tnew = tnew + a11 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b12 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a12 * kdu

    tnew = tnew + a12 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b13 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a13 * kdu

    tnew = tnew + a13 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b14 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a14 * kdu

    tnew = tnew + a14 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b15 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a15 * kdu

    tnew = tnew + a15 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b16 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a16 * kdu

    tnew = tnew + a16 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b17 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a17 * kdu

    tnew = tnew + a17 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b18 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a18 * kdu

    tnew = tnew + a18 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b19 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a19 * kdu

    tnew = tnew + a19 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b20 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a20 * kdu

    tnew = tnew + a20 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b21 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a21 * kdu

    tnew = tnew + a21 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b22 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a22 * kdu

    tnew = tnew + a22 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b23 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a23 * kdu

    tnew = tnew + a23 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b24 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a24 * kdu

    tnew = tnew + a24 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b25 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a25 * kdu

    tnew = tnew + a25 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b26 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a26 * kdu

    tnew = tnew + a26 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b27 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a27 * kdu

    tnew = tnew + a27 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b28 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a28 * kdu

    tnew = tnew + a28 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b29 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a29 * kdu

    tnew = tnew + a29 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b30 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a30 * kdu

    tnew = tnew + a30 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b31 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a31 * kdu

    tnew = tnew + a31 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b32 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a32 * kdu

    tnew = tnew + a32 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b33 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a33 * kdu

    tnew = tnew + a33 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b34 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a34 * kdu

    tnew = tnew + a34 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b35 * ku

    f.f1(kdu, du, u, p, tnew)
    @.. broadcast=false du=du + dt * a35 * kdu

    tnew = tnew + a35 * dt
    f.f2(ku, du, u, p, tnew)
    @.. broadcast=false u=u + dt * b36 * ku

    f.f1(kdu, du, u, p, tnew)
    # @.. broadcast=false du = du + dt*a30*kdu
    f.f2(ku, du, u, p, tnew)

    OrdinaryDiffEqCore.increment_nf!(integrator.stats, 36)
    integrator.stats.nf2 += 36
    store_symp_state!(integrator, cache, kdu, ku)
end

abstract type HamiltonMutableCache <: OrdinaryDiffEqMutableCache end
abstract type HamiltonConstantCache <: OrdinaryDiffEqConstantCache end

@cache struct SymplecticEulerCache{uType, rateType} <: HamiltonMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
end

function alg_cache(
        alg::SymplecticEuler, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SymplecticEulerCache(u, uprev, zero(u), zero(rate_prototype), zero(rate_prototype))
end

struct SymplecticEulerConstantCache <: HamiltonConstantCache end

function alg_cache(
        alg::SymplecticEuler, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SymplecticEulerConstantCache()
end

@cache struct VelocityVerletCache{uType, rateType, uEltypeNoUnits} <:
    OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
    half::uEltypeNoUnits
end

struct VelocityVerletConstantCache{uEltypeNoUnits} <: HamiltonConstantCache
    half::uEltypeNoUnits
end

function alg_cache(
        alg::VelocityVerlet, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(rate_prototype)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    half = uEltypeNoUnits(1 // 2)
    return VelocityVerletCache(u, uprev, k, tmp, fsalfirst, half)
end

function alg_cache(
        alg::VelocityVerlet, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return VelocityVerletConstantCache(uEltypeNoUnits(1 // 2))
end

@cache struct LeapfrogDriftKickDriftCache{uType, rateType, uEltypeNoUnits} <:
    OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
    half::uEltypeNoUnits
end

struct LeapfrogDriftKickDriftConstantCache{uEltypeNoUnits} <: HamiltonConstantCache
    half::uEltypeNoUnits
end

function alg_cache(
        alg::LeapfrogDriftKickDrift, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(rate_prototype)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    half = uEltypeNoUnits(1 // 2)
    return LeapfrogDriftKickDriftCache(u, uprev, k, tmp, fsalfirst, half)
end

function alg_cache(
        alg::LeapfrogDriftKickDrift, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return LeapfrogDriftKickDriftConstantCache(uEltypeNoUnits(1 // 2))
end

@cache struct VerletLeapfrogCache{uType, rateType, uEltypeNoUnits} <:
    OrdinaryDiffEqMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
    half::uEltypeNoUnits
end

struct VerletLeapfrogConstantCache{uEltypeNoUnits} <: HamiltonConstantCache
    half::uEltypeNoUnits
end

function alg_cache(
        alg::VerletLeapfrog, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    half = uEltypeNoUnits(1 // 2)
    return VerletLeapfrogCache(u, uprev, k, tmp, fsalfirst, half)
end

function alg_cache(
        alg::VerletLeapfrog, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return VerletLeapfrogConstantCache(uEltypeNoUnits(1 // 2))
end

@cache struct Symplectic2Cache{uType, rateType, tableauType} <: HamiltonMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
    tab::tableauType
end

function alg_cache(
        alg::PseudoVerletLeapfrog, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = PseudoVerletLeapfrogConstantCache(
        constvalue(uBottomEltypeNoUnits),
        constvalue(tTypeNoUnits)
    )
    return Symplectic2Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::PseudoVerletLeapfrog, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return PseudoVerletLeapfrogConstantCache(
        constvalue(uBottomEltypeNoUnits),
        constvalue(tTypeNoUnits)
    )
end

function alg_cache(
        alg::McAte2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = McAte2ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return Symplectic2Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::McAte2, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return McAte2ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct Symplectic3Cache{uType, rateType, tableauType} <: HamiltonMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
    tab::tableauType
end

function alg_cache(
        alg::Ruth3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = Ruth3ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return Symplectic3Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::Ruth3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return Ruth3ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

function alg_cache(
        alg::McAte3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = McAte3ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return Symplectic3Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::McAte3, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return McAte3ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct Symplectic4Cache{uType, rateType, tableauType} <: HamiltonMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
    tab::tableauType
end

function alg_cache(
        alg::McAte4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = McAte4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return Symplectic4Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::McAte4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return McAte4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

function alg_cache(
        alg::CandyRoz4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = CandyRoz4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return Symplectic4Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::CandyRoz4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return McAte4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct Symplectic45Cache{uType, rateType, tableauType} <: HamiltonMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
    tab::tableauType
end

function alg_cache(
        alg::CalvoSanz4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = CalvoSanz4ConstantCache(
        constvalue(uBottomEltypeNoUnits),
        constvalue(tTypeNoUnits)
    )
    return Symplectic45Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::CalvoSanz4, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return CalvoSanz4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

function alg_cache(
        alg::McAte42, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = McAte42ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return Symplectic45Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::McAte42, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return McAte42ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct Symplectic5Cache{uType, rateType, tableauType} <: HamiltonMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
    tab::tableauType
end

function alg_cache(
        alg::McAte5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = McAte5ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return Symplectic5Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::McAte5, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return McAte5ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct Symplectic6Cache{uType, rateType, tableauType} <: HamiltonMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
    tab::tableauType
end

function alg_cache(
        alg::Yoshida6, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = Yoshida6ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return Symplectic6Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::Yoshida6, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return Yoshida6ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct Symplectic62Cache{uType, rateType, tableauType} <: HamiltonMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
    tab::tableauType
end

function alg_cache(
        alg::KahanLi6, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = KahanLi6ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return Symplectic62Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::KahanLi6, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return KahanLi6ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct McAte8Cache{uType, rateType, tableauType} <: HamiltonMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
    tab::tableauType
end

function alg_cache(
        alg::McAte8, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = McAte8ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return McAte8Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::McAte8, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return McAte8ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct KahanLi8Cache{uType, rateType, tableauType} <: HamiltonMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
    tab::tableauType
end

function alg_cache(
        alg::KahanLi8, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = KahanLi8ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return KahanLi8Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::KahanLi8, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return KahanLi8ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

@cache struct SofSpa10Cache{uType, rateType, tableauType} <: HamiltonMutableCache
    u::uType
    uprev::uType
    tmp::uType
    k::rateType
    fsalfirst::rateType
    tab::tableauType
end

function alg_cache(
        alg::SofSpa10, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{true}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    tmp = zero(u)
    k = zero(rate_prototype)
    fsalfirst = zero(rate_prototype)
    tab = SofSpa10ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
    return SofSpa10Cache(u, uprev, k, tmp, fsalfirst, tab)
end

function alg_cache(
        alg::SofSpa10, u, rate_prototype, ::Type{uEltypeNoUnits},
        ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
        dt, reltol, p, calck,
        ::Val{false}, verbose
    ) where {uEltypeNoUnits, uBottomEltypeNoUnits, tTypeNoUnits}
    return SofSpa10ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
end

function get_fsalfirstlast(
        cache::Union{
            HamiltonMutableCache, VelocityVerletCache, VerletLeapfrogCache,
            SymplecticEulerCache, LeapfrogDriftKickDriftCache,
        }, u
    )
    return (cache.fsalfirst, cache.k)
end

alg_order(alg::SymplecticEuler) = 1
alg_order(alg::VelocityVerlet) = 2
alg_order(alg::VerletLeapfrog) = 2
alg_order(alg::LeapfrogDriftKickDrift) = 2
alg_order(alg::PseudoVerletLeapfrog) = 2
alg_order(alg::McAte2) = 2
alg_order(alg::Ruth3) = 3
alg_order(alg::McAte3) = 3
alg_order(alg::McAte4) = 4
alg_order(alg::CandyRoz4) = 4
alg_order(alg::CalvoSanz4) = 4
alg_order(alg::McAte42) = 4
alg_order(alg::McAte5) = 5
alg_order(alg::Yoshida6) = 6
alg_order(alg::KahanLi6) = 6
alg_order(alg::McAte8) = 8
alg_order(alg::KahanLi8) = 8
alg_order(alg::SofSpa10) = 10
